searchNodes=[{"doc":"PhxComponentHelpers are helper functions meant to be used within Phoenix LiveView live_components to make your components more configurable and extensible from your templates. It provides following features: set HTML or data attributes from component assigns set phx_* attributes from component assigns set attributes with any custom prefix such as @click or x-bind: from alpinejs encode attributes as JSON from an Elixir structure assign validate mandatory attributes set and extend CSS classes from component assigns","ref":"PhxComponentHelpers.html","title":"PhxComponentHelpers","type":"module"},{"doc":"Set assigns with class attributes. The class attribute will take provided default_classes as a default value and will be extended, on a class-by-class basis, by your assigns. This function will identify default classes to be replaced by assigns on a prefix basis: &quot;bg-gray-200&quot; will be overwritten by &quot;bg-blue-500&quot; because they share the same &quot;bg-&quot; prefix &quot;hover:bg-gray-200&quot; will be overwritten by &quot;hover:bg-blue-500&quot; because they share the same &quot;hover:bg-&quot; prefix &quot;m-1&quot; would not be overwritten by &quot;mt-1&quot; because they don't share the same prefix (&quot;m-&quot; vs &quot;mt-&quot;) Parameters assigns - your component assigns default_classes - the default classes that will be overridden by your assigns. This parameter can be a binary or a single parameter function that receives all assigns and returns a binary Options :attribute - read &amp; write css classes from &amp; into this key Example assigns |&gt; extend_class ( &quot;bg-blue-500 mt-8&quot; ) |&gt; extend_class ( &quot;py-4 px-2 divide-y-8 divide-gray-200&quot; , attribute : :wrapper_class ) |&gt; extend_class ( fn assigns -&gt; default = &quot;p-2 m-4 text-sm &quot; if assigns [ :active ] , do : default &lt;&gt; &quot;bg-indigo-500&quot; , else : default &lt;&gt; &quot;bg-gray-200&quot; end ) assigns now contains @raw_class , @raw_wrapper_class , @heex_class and @heex_wrapper_class . If your input assigns were %{class: &quot;mt-2&quot;, wrapper_class: &quot;divide-none&quot;} then: @raw_class and @heex_class would contain &quot;bg-blue-500 mt-2&quot; @raw_wrapper_class and @heex_wrapper_class would contain &quot;py-4 px-2 divide-none&quot;","ref":"PhxComponentHelpers.html#extend_class/3","title":"PhxComponentHelpers.extend_class/3","type":"function"},{"doc":"Forward and filter assigns to sub components. By default it doesn't forward anything unless you provide it with any combination of the options described below. Parameters assigns - your component assigns Options prefix - will only forward assigns prefixed by the given prefix. Forwarded assign key will no longer have the prefix take - is a list of key (without prefix) that will be picked from assigns to be forwarded merge - takes a map that will be merged as-is to the output assigns If both options are given at the same time, the resulting assigns will be the union of the two. Example Following will forward an assign map containing %{button_id: 42, button_label: &quot;label&quot;, phx_click: &quot;save&quot;} as %{id: 42, label: &quot;label&quot;, phx_click: &quot;save&quot;} forward_assigns ( assigns , prefix : :button , take : [ :phx_click ] )","ref":"PhxComponentHelpers.html#forward_assigns/2","title":"PhxComponentHelpers.forward_assigns/2","type":"function"},{"doc":"If assigns include form and field entries, this function will let you know if the given field is in error or not. Returns true or false. Parameters assigns - your component assigns, which should have form and field keys.","ref":"PhxComponentHelpers.html#has_errors?/1","title":"PhxComponentHelpers.has_errors?/1","type":"function"},{"doc":"Extends assigns with raw_* attributes that can be interpolated within your component markup. Parameters assigns - your component assigns attributes - a list of attributes (atoms) that will be fetched from assigns. Attributes can either be single atoms or tuples in the form {:atom, default} to provide default values. Options :required - raises if required attributes are absent from assigns :json - when true, will JSON encode the assign value :data - when true, HTML attributes are prefixed with data- :into - merges all assigns in a single one that can be interpolated at once Example assigns |&gt; set_attributes ( [ :id , :name , label : &quot;default label&quot; ] , required : [ :id , :name ] , into : :attributes ) |&gt; set_attributes ( [ :value ] , json : true ) assigns now contains : @raw_id , @raw_name , @raw_label and @raw_value . @raw_attributes which holds the values if :id , :name and :label . @heex_id , @heex_name , @heex_label and @heex_value . @heex_attributes which holds the values if :id , :name and :label . raw attributes are meant to be used in leex templates whereas heex attributes will be used in heex templates.","ref":"PhxComponentHelpers.html#set_attributes/3","title":"PhxComponentHelpers.set_attributes/3","type":"function"},{"doc":"Extends assigns with form related attributes. If assigns contain :form and :field keys then it will set :id , :name , :for , :value , and :errors from received Phoenix.HTML.Form . Parameters assigns - your component assigns Example assigns |&gt; set_form_attributes ( )","ref":"PhxComponentHelpers.html#set_form_attributes/1","title":"PhxComponentHelpers.set_form_attributes/1","type":"function"},{"doc":"Just a convenient method built on top of set_prefixed_attributes/3 for phx attributes. It will automatically detect any attribute prefixed by phx_ from input assigns. By default, the :into option of set_prefixed_attributes/3 is :phx_attributes Example assigns |&gt; set_phx_attributes ( required : [ :phx_submit ] , init : [ :phx_change ] ) assigns now contains @raw_phx_change , @raw_phx_submit and @raw_phx_attributes . @heex_phx_change , @heex_phx_submit and @heex_phx_attributes .","ref":"PhxComponentHelpers.html#set_phx_attributes/2","title":"PhxComponentHelpers.set_phx_attributes/2","type":"function"},{"doc":"Extends assigns with prefixed attributes that can be interpolated within your component markup. It will automatically detect any attribute prefixed by any of the given prefixes from input assigns. Can be used for intance to easily map alpinejs html attributes. Parameters assigns - your component assigns prefixes - a list of prefix as binaries Options :init - a list of attributes that will be initialized if absent from assigns :required - raises if required attributes are absent from assigns :into - merges all assigns in a single one that can be interpolated at once Example assigns |&gt; set_prefixed_attributes ( [ &quot;@click&quot; , &quot;x-bind:&quot; ] , required : [ &quot;x-bind:class&quot; ] , into : :alpine_attributes ) assigns now contains @raw_click , @raw_x-bind:class and @raw_alpine_attributes . @heex_click , @heex_x-bind:class and @heex_alpine_attributes .","ref":"PhxComponentHelpers.html#set_prefixed_attributes/3","title":"PhxComponentHelpers.set_prefixed_attributes/3","type":"function"},{"doc":"Validates that attributes are present in assigns. Raises an ArgumentError if any attribute is missing. Example assigns |&gt; validate_required_attributes ( [ :id , :label ] )","ref":"PhxComponentHelpers.html#validate_required_attributes/2","title":"PhxComponentHelpers.validate_required_attributes/2","type":"function"},{"doc":"PhxComponentHelpers are helper functions meant to be used within Phoenix your views to facilitate usage of live_components inside templates.","ref":"PhxViewHelpers.html","title":"PhxViewHelpers","type":"module"},{"doc":"Extends Phoenix.HTML.Form.form_for/3 options to merge css class as with PhxComponentHelpers.extend_class/2 . It's useful to define your own form_for functions with default css classes that still can be overriden from the template. Example def my_form_for ( form_data , action , options ) when is_list ( options ) do new_options = extend_form_class ( options , &quot;mt-4 space-y-2&quot; ) form_for ( form_data , action , new_options ) end","ref":"PhxViewHelpers.html#extend_form_class/2","title":"PhxViewHelpers.extend_form_class/2","type":"function"},{"doc":"👉 Demonstration &amp; Code samples","ref":"readme.html","title":"PhxComponentHelpers","type":"extras"},{"doc":"PhxComponentHelpers provides helper functions meant to be used within Phoenix LiveView to make your components more configurable and extensible from templates. It provides the following features: set HTML, data or phx attributes from component assigns set a bunch of attributes at once with any custom prefix such as @click or x-bind: (for alpinejs users) validate mandatory attributes set and extend CSS classes from component assigns forward a subset of assigns to child components","ref":"readme.html#presentation","title":"PhxComponentHelpers - Presentation","type":"extras"},{"doc":"Writing a library of stateless components is a great way to improve consistency in both your UI and code and also to get a significant productivity boost. The best components can be used as-is without any further configuration, but are versatile enough to be customized from templates or higher level components. Writing such components is not difficult, but involves a lot of boilerplate code. PhxComponentHelpers is here to alleviate the pain.","ref":"readme.html#motivation","title":"PhxComponentHelpers - Motivation","type":"extras"},{"doc":"A lot of code samples are available on this site , but basically PhxComponentHelpers allows you to write components as such: defmodule Forms.Button do use Phoenix.Component import PhxComponentHelpers def button ( assigns ) do assigns = assigns |&gt; extend_class ( &quot;bg-blue-700 hover:bg-blue-900 ...&quot; ) |&gt; set_attributes ( [ :type , :id , :label ] , required : [ :id ] ) |&gt; set_phx_attributes ( ) ~H&quot;&quot;&quot; &lt;button {@heex_id} {@heex_type} {@heex_phx_attributes} {@heex_class}&gt; &lt;%= @label %&gt; &lt;/button&gt; &quot;&quot;&quot; end end From templates, it looks like this: &lt;.form id=&quot;form&quot; phx_submit=&quot;form_submit&quot; class=&quot;divide-none&quot;&gt; &lt;.input_group&gt; &lt;.label for=&quot;name&quot; label=&quot;Name&quot;/&gt; &lt;.text_input name=&quot;name&quot; value={@my.name}/&gt; &lt;/.input_group&gt; &lt;.button_group class=&quot;pt-2&quot;&gt; &lt;.button type=&quot;submit&quot; phx_click=&quot;btn-click&quot; label=&quot;Save&quot;/&gt; &lt;/.button_group&gt; &lt;/.form&gt;","ref":"readme.html#example","title":"PhxComponentHelpers - Example","type":"extras"},{"doc":"PETAL stands for Phoenix - Elixir - TailwindCSS - Alpine.js - LiveView. In recent months it has become quite popular in the Elixir ecosystem and PhxComponentHelpers is meant to fit in. TailwindCSS provides a new way to structure CSS, but keeping good HTML hygiene requires to rely on a component-oriented library. Alpine.js is the Javascript counterpart of Tailwind. It lets you define dynamic behaviour right from your templates using HTML attributes. The point of developing good components is to provide strong defaults in the component so that they can be used as -is, but also to let these defaults be overridden right from the templates. Here is the definition of a typical Form button, with Tailwind &amp; Alpine : defmodule Forms.Button do use Phoenix.Component import PhxComponentHelpers @css_class &quot;inline-flex items-center justify-center p-3 w-5 h-5 border \\ border-transparent text-2xl leading-4 font-medium rounded-md \\ text-white bg-primary hover:bg-primary-hover&quot; def button ( assigns ) do assigns = assigns |&gt; extend_class ( @css_class ) |&gt; set_phx_attributes ( ) |&gt; set_prefixed_attributes ( [ &quot;@click&quot; , &quot;x-bind:&quot; ] , into : :alpine_attributes , required : [ &quot;@click&quot; ] ) ~H&quot;&quot;&quot; &lt;button type=&quot;button&quot; {@heex_class} {@heex_alpine_attributes} {@heex_phx_attributes}&gt; &lt;%= render_block(@inner_block) %&gt; &lt;/button&gt; &quot;&quot;&quot; end end Then in your html.leex template you can imagine the following code, providing @click behaviour and overriding just the few tailwind css classes you need (only p-* , w-* and h-* will be replaced). No phx behaviour here, but it's ok, it won't break ;-) &lt; . button class = &quot;p-0 w-7 h-7&quot; &quot;@click&quot; = &quot;$dispatch(&#39;closeslideover&#39;)&quot; &gt; &lt; . icon icon = { :plus_circle } / &gt; &lt; / . button &gt;","ref":"readme.html#how-does-it-play-with-the-petal-stack","title":"PhxComponentHelpers - How does it play with the PETAL stack?","type":"extras"},{"doc":"This library also provides Phoenix.HTML.Form related functions so you can easily write your own my_form_for function with your css defaults. def my_form_for ( options ) when is_list ( options ) do options |&gt; extend_form_class ( &quot;mt-4 space-y-2&quot; ) |&gt; Phoenix.LiveView.Helpers . form ( ) end Then you only need to use PhxComponentHelpers.set_form_attributes/1 within your own form components in order to fetch names &amp; values from the form. Your template will then look like this: &lt;.my_form_for let={f} for={@changeset} phx_submit=&quot;form_submit&quot; class=&quot;divide-none&quot;&gt; &lt;.input_group&gt; &lt;.label form={f} field={:name} label=&quot;Name&quot;/&gt; &lt;.text_input form={f} field={:name}/&gt; &lt;/.input_group&gt; &lt;.button_group class=&quot;pt-2&quot;&gt; &lt;.button type=&quot;submit&quot; label=&quot;Save&quot;/&gt; &lt;/.button_group&gt; &lt;/.my_form_for&gt;","ref":"readme.html#forms","title":"PhxComponentHelpers - Forms","type":"extras"},{"doc":"Surface is a library built on top of Phoenix LiveView. Surface is much more ambitious and complex than PhxComponentHelpers (which obviously isn't a framework, just helpers ...). Surface really changes the way you code user interfaces and components (you almost won't be using HTML templates anymore) whereas PhxComponentHelpers is just some syntactic sugar to help you use raw phoenix_live_view .","ref":"readme.html#compared-to-surface","title":"PhxComponentHelpers - Compared to Surface","type":"extras"},{"doc":"Available on https://hexdocs.pm","ref":"readme.html#documentation","title":"PhxComponentHelpers - Documentation","type":"extras"},{"doc":"Add the following to your mix.exs . def deps do [ { :phx_component_helpers , &quot;~&gt; 0.13.0&quot; } , { :jason , &quot;~&gt; 1.0&quot; } # only required if you want to use json encoding options ] end","ref":"readme.html#installation","title":"PhxComponentHelpers - Installation","type":"extras"}]